/*****************************************************
This program was produced by the
CodeWizardAVR V2.05.0 Professional
Automatic Program Generator
 Copyright 1998-2010 Pavel Haiduc, HP InfoTech s.r.l.
http://www.hpinfotech.com

Project : 
Version : 
Date    : 30.11.2011
Author  : NeVaDa
Company : 
Comments: 


Chip type               : ATmega16
Program type            : Application
AVR Core Clock frequency: 20,000000 MHz
Memory model            : Small
External RAM size       : 0
Data Stack size         : 1024
*****************************************************/

#include <mega16.h>
#include <delay.h>

#include <n3310lcd.c>
#include <stdio.h>
#include <stdlib.h>



#define backlight_duration	5
#define max_prog		95
#define max_segm		20

#define shuffle			1

#define SPI_PORT        PORTB
#define SPI_DDR         DDRB

#define SS_PIN          4
#define MOSI_PIN        5
#define MISO_PIN        6
#define SCK_PIN         7 
                  
#define strobe_PORT     PORTB
#define strobe_DDR      DDRB
#define strobe_PIN      3
#define strobe_toggle() {strobe_PORT.strobe_PIN = 1; strobe_PORT.strobe_PIN = 0;}

#define but1 	!PINA.4
#define but2 	!PINA.5
#define but3 	!PINA.2
#define but4 	!PINA.3
#define but5 	!PINC.1
#define but6 	!PINC.0

#define backlight	PORTA.1

#define buzzer_on() 	PORTC.2 = 1
#define buzzer_off() 	PORTC.2 = 0 

#define red	0b10001000
#define green	0b01000010
#define blue	0b00010001
#define white	0b11011011

unsigned char segm, prog, speed_array[max_prog+1];
unsigned char null1;
unsigned char null2;
unsigned char null3;
unsigned char null4;
unsigned char null5;
unsigned char null6;
unsigned char null7;
unsigned char null8;
unsigned char view_array[max_segm];
eeprom unsigned int null;
eeprom unsigned char e_segm;
eeprom unsigned char e_prog;
eeprom unsigned char e_speed_array[max_prog+1];

unsigned char null21;
unsigned char null22;
unsigned char null23;
unsigned char null24;
unsigned char null25;
unsigned char null26;
unsigned char null27;
unsigned char null28;

unsigned char backlight_cnt = 0;
unsigned char prog_flag = 0;
unsigned char speed_flag = 0;
unsigned char segm_flag = 0;

unsigned char shuffle_flag = 0;

unsigned char i;

unsigned char prog_step;
unsigned char stop_flag;

#include <effects.c>
#include <red.c>
#include <green.c>
#include <blue.c>

unsigned int s1_cnt = 0;       //   1

// Timer 0 overflow interrupt service routine
interrupt [TIM0_OVF] void timer0_ovf_isr(void)
        {
        TCNT0=0xB2;	//  10 
        #asm("wdr")
        
        if (++s1_cnt == 100)
        	{
                s1_cnt = 0;
                
                if (backlight_cnt) {backlight_cnt--; backlight = 1;}
                	else backlight = 0;
                }
                
        for (i=0;i<segm;i++)
        	{
                SPDR = view_array[i];
                while (!SPSR.7) #asm ("wdr");
                } 
        
        strobe_toggle();        // Strobe 
        }

void SPIInit(void)
        {
        unsigned char i=0, temp;     // 
        
                                // setup SPI I/O pins
        SPI_DDR.SCK_PIN = 1;    // set SCK as output
        SPI_PORT.SCK_PIN = 0;   // set SCK lo
        
        SPI_DDR.MISO_PIN = 0;   // set MISO as input
        SPI_PORT.MISO_PIN = 1;  // set pullup
        
        SPI_DDR.MOSI_PIN = 1;   // set MOSI as output
        
        SPI_DDR.SS_PIN = 1;     // SS must be output for Master mode to work
        
        strobe_DDR.strobe_PIN = 1;      //     
        strobe_PORT.strobe_PIN = 0;     //  
        
                                //SPI Mode: 0
	                                
        SPCR.0 = 1;             //SPI Clock Rate Select
	SPCR.1 = 1;             //
	SPSR.0 = 0;             //SPI2X: Double SPI Speed Bit -    2
	SPCR.2 = 0;             //CPHA: Clock Phase (  - 1)- . 
	SPCR.3 = 0;             //CPOL: Clock Polarity (0:   - ,   - ) - . 
	SPCR.4 = 1;             //MSTR: Master(1)/Slave(0) Select
	SPCR.5 = 0;             //DORD: Data Order (LSB first = 1; MSB first = 0)
	SPCR.6 = 1;             //SPE: SPI Enable = 1
	SPCR.7 = 0;             //SPIE: SPI Interrupt Enable = 1
	
	temp = SPSR;            //clear SPI status (. )
	temp = SPDR;
	
	while (++i) {SPDR = 0; while (!SPSR.7) #asm("wdr");};       //  0
	strobe_toggle();        // Strobe 
        };
        
void sound_on (int time)	//  
        {
        int i = 0;
        while (i < time*2)
                {  
                buzzer_on();
                delay_us(250);
                buzzer_off();
                delay_us(250);                
                i++;
                }                                                
        }

void main(void)
{
// Declare your local variables here

// Input/Output Ports initialization
// Port A initialization
// Func7=In Func6=In Func5=In Func4=In Func3=In Func2=In Func1=Out Func0=In 
// State7=T State6=T State5=P State4=P State3=P State2=P State1=0 State0=T 
PORTA=0x3C;
DDRA=0x02;

// Port B initialization
// Func7=In Func6=In Func5=In Func4=In Func3=In Func2=In Func1=In Func0=In 
// State7=T State6=T State5=T State4=T State3=T State2=T State1=T State0=T 
PORTB=0x00;
DDRB=0x00;

// Port C initialization
// Func7=In Func6=In Func5=In Func4=In Func3=In Func2=Out Func1=In Func0=In 
// State7=T State6=T State5=T State4=T State3=T State2=0 State1=P State0=P 
PORTC=0x03;
DDRC=0x04;

// Port D initialization
// Func7=In Func6=In Func5=In Func4=In Func3=In Func2=In Func1=In Func0=In 
// State7=T State6=T State5=T State4=T State3=T State2=T State1=T State0=T 
PORTD=0x00;
DDRD=0x00;

// Timer/Counter 0 initialization
// Clock source: System Clock
// Clock value: 7,813 kHz
// Mode: Normal top=0xFF
// OC0 output: Disconnected
TCCR0=0x05;
TCNT0=0xB2;
OCR0=0x00;

// Timer/Counter 1 initialization
// Clock source: System Clock
// Clock value: Timer1 Stopped
// Mode: Normal top=0xFFFF
// OC1A output: Discon.
// OC1B output: Discon.
// OC1C output: Discon.
// Noise Canceler: Off
// Input Capture on Falling Edge
// Timer1 Overflow Interrupt: Off
// Input Capture Interrupt: Off
// Compare A Match Interrupt: Off
// Compare B Match Interrupt: Off
// Compare C Match Interrupt: Off
TCCR1A=0x00;
TCCR1B=0x00;
TCNT1H=0x00;
TCNT1L=0x00;
ICR1H=0x00;
ICR1L=0x00;
OCR1AH=0x00;
OCR1AL=0x00;
OCR1BH=0x00;
OCR1BL=0x00;

// Timer/Counter 2 initialization
// Clock source: System Clock
// Clock value: Timer2 Stopped
// Mode: Normal top=0xFF
// OC2 output: Disconnected
TCCR2=0x00;
TCNT2=0x00;
OCR2=0x00;

// Timer(s)/Counter(s) Interrupt(s) initialization
TIMSK=0x01;

// Analog Comparator initialization
// Analog Comparator: Off
// Analog Comparator Input Capture by Timer/Counter 1: Off
ACSR=0x80;
SFIOR=0x00;

// ADC initialization
// ADC disabled
ADCSRA=0x00;

// SPI initialization
// SPI disabled
SPCR=0x00;

// TWI initialization
// TWI disabled
TWCR=0x00;

SPIInit();

LcdInit();

backlight = 1;
  
//sound_on(30);

null1 = null2 = null3 = null4 = null5 = null6 = null7 = null8 = 255;
null21 = null22 = null23 = null24 = null25 = null26 = null27 = null28 = 255;

if (null > 1)
	{
        null = 0;
        e_segm = 20;
        e_prog = 1;
        for (i=0;i<max_prog+1;i++) e_speed_array[i] = 90;
        }

for (i=0;i<max_prog+1;i++) speed_array[i] = e_speed_array[i];
segm = e_segm;
prog = e_prog;

if (prog == shuffle) shuffle_flag = 1;
	else shuffle_flag = stop_flag = 0;

// Watchdog Timer initialization
// Watchdog Timer Prescaler: OSC/2048k
#pragma optsize-
WDTCR=0x1F;
WDTCR=0x0F;
#ifdef _OPTIMIZE_SIZE_
#pragma optsize+
#endif

// Global enable interrupts
#asm("sei")

backlight_cnt = backlight_duration;

sprintf (lcd_buf, "");
LcdStringBig(1,1);
sprintf (lcd_buf, "%02u", prog);
LcdStringBold(11,1);
sprintf (lcd_buf, "");
LcdStringBig(1,3);
sprintf (lcd_buf, "%02u", speed_array[prog]);
LcdStringBold(11,3);
sprintf (lcd_buf, "");
LcdStringBig(1,5);
sprintf (lcd_buf, "%02u", segm);
LcdStringBold(11,5);
        
LcdUpdate();

while (1)
      	{
      	if (but1 || but2 || but3 || but4 || but5 || but6) 
        	{
                sound_on(3);
                if (shuffle_flag == 1) 
                	{
                        prog = shuffle;
                        segm = e_segm;
                        }
                }
        while (but1 || but2 || but3 || but4 || but5 || but6)
        	{
                backlight_cnt = backlight_duration;
                backlight = 1;
                delay_ms(5);
                
                if (but1)
                	{
                        //if (shuffle_flag) {prog = 1; segm = e_segm;}
                        prog++;
                        if (prog == max_prog+1) prog = 0;
                        prog_flag = 1;
                        }
                if (but2)
                	{
                        //if (shuffle_flag) {prog = 1; segm = e_segm;}
                        prog--;
                        if (prog > max_prog) prog = max_prog;
                        prog_flag = 1;
                        }
                if (but3 && prog > 1)
                	{
                        speed_array[prog]++;
                        if (speed_array[prog] == 100) speed_array[prog] = 1;
                        speed_flag = 1;
                        }
                if (but4 && prog > 1)
                	{
                        speed_array[prog]--;
                        if (speed_array[prog] == 0) speed_array[prog] = 99;
                        speed_flag = 1;
                        } 
                if (but5)
                	{
                        //if (shuffle_flag) {prog = 1; segm = e_segm;} 
                        segm++;
                        if (segm == max_segm+1) segm = 1;
                        segm_flag = 1;
                        }
                if (but6)
                	{
                        //if (shuffle_flag) {prog = 1; segm = e_segm;} 
                        segm--;
                        if (segm == 0) segm = max_segm;
                        segm_flag = 1;
                        }                 
                
                sprintf (lcd_buf, "");
                LcdStringBig(1,1);
                sprintf (lcd_buf, "%02u", prog);
                LcdStringBold(11,1);
                sprintf (lcd_buf, "");
                LcdStringBig(1,3);
                sprintf (lcd_buf, "%02u", speed_array[prog]);
                LcdStringBold(11,3);
                sprintf (lcd_buf, "");
                LcdStringBig(1,5);
                sprintf (lcd_buf, "%02u", segm);
                LcdStringBold(11,5);
                        
                LcdUpdate();
                delay_ms(50);
                
                if (prog == shuffle) shuffle_flag = 1;
                	else shuffle_flag = stop_flag = 0;
                }
        
        if (prog_flag)
                {
                prog_flag = 0;
                e_prog = prog;
                }
        if (speed_flag)
                {
                speed_flag = 0;
                e_speed_array[prog] = speed_array[prog];
                }
        if (segm_flag)
                {
                segm_flag = 0;
                e_segm = segm;
                }
                
        for (i=0;i<max_prog+1;i++) speed_array[i] = e_speed_array[i];
        
        //         
        while (prog == 0 && !(but1 || but2 || but3 || but4 || but5 || but6))
        	{
                i = 0;
                for (i=0;i<segm;i++) view_array[i] = 0;
                }
        
        prog_step = 0;
        if (!shuffle_flag) segm = e_segm;
        while (prog == 2 && !(but1 || but2 || but3 || but4 || but5 || but6) && !stop_flag) effect8(); 
        
        prog_step = 0;
        if (!shuffle_flag) segm = e_segm;
        while (prog == 3 && !(but1 || but2 || but3 || but4 || but5 || but6) && !stop_flag) effect9();
        
        prog_step = 0;
        if (!shuffle_flag) segm = e_segm;
        while (prog == 4 && !(but1 || but2 || but3 || but4 || but5 || but6) && !stop_flag) effect10();
        
        prog_step = 0;
        if (!shuffle_flag) segm = e_segm;
        while (prog == 5 && !(but1 || but2 || but3 || but4 || but5 || but6) && !stop_flag) effect11();
        
        prog_step = 0;
        if (!shuffle_flag) segm = e_segm;
        while (prog == 6 && !(but1 || but2 || but3 || but4 || but5 || but6) && !stop_flag) effect12();
        
        prog_step = 0;
        if (!shuffle_flag) segm = e_segm;
        while (prog == 7 && !(but1 || but2 || but3 || but4 || but5 || but6) && !stop_flag) effect13();
        
        prog_step = 0;
        if (!shuffle_flag) segm = e_segm;
        while (prog == 8 && !(but1 || but2 || but3 || but4 || but5 || but6) && !stop_flag) effect14();
        
        prog_step = 0;
        if (!shuffle_flag) segm = e_segm;
        while (prog == 9 && !(but1 || but2 || but3 || but4 || but5 || but6) && !stop_flag) effect15();
        
        if (!shuffle_flag) segm = e_segm;
        prog_step = (segm+2)/2;
        while (prog == 10 && !(but1 || but2 || but3 || but4 || but5 || but6) && !stop_flag) effect16();
        
        prog_step = 0;
        if (!shuffle_flag) segm = e_segm;
        while (prog == 11 && !(but1 || but2 || but3 || but4 || but5 || but6) && !stop_flag) effect17(); 
        
        red_func();
        green_func();
        blue_func();
        
        //  	
        if (shuffle_flag)
        	{
                stop_flag = 0;
                prog = (unsigned char)((unsigned int)rand()/352+2);
                if (rand()>16384) segm = 10;
                	else segm = 20;
                }
        
        }
}
